diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/class-wp-terms-list-table.php ./wordpress-3.3/wp-admin/includes/class-wp-terms-list-table.php
*** ./wordpress-3.2.1/wp-admin/includes/class-wp-terms-list-table.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/class-wp-terms-list-table.php	2011-11-23 09:20:45.000000000 -0600
***************
*** 24,30 ****
  
  		$tax = get_taxonomy( $taxonomy );
  
! 		if ( empty( $post_type ) || !in_array( $post_type, get_post_types( array( 'public' => true ) ) ) )
  			$post_type = 'post';
  
  		parent::__construct( array(
--- 24,30 ----
  
  		$tax = get_taxonomy( $taxonomy );
  
! 		if ( empty( $post_type ) || !in_array( $post_type, get_post_types( array( 'show_ui' => true ) ) ) )
  			$post_type = 'post';
  
  		parent::__construct( array(
***************
*** 93,99 ****
  	}
  
  	function get_columns() {
! 		global $taxonomy, $typenow;
  
  		$columns = array(
  			'cb'          => '<input type="checkbox" />',
--- 93,99 ----
  	}
  
  	function get_columns() {
! 		global $taxonomy, $post_type;
  
  		$columns = array(
  			'cb'          => '<input type="checkbox" />',
***************
*** 105,111 ****
  		if ( 'link_category' == $taxonomy ) {
  			$columns['links'] = __( 'Links' );
  		} else {
- 			$post_type = empty( $typenow ) ? 'post' : $typenow;
  			$post_type_object = get_post_type_object( $post_type );
  			$columns['posts'] = $post_type_object ? $post_type_object->labels->name : __( 'Posts' );
  		}
--- 105,110 ----
***************
*** 290,296 ****
  
  		$tax = get_taxonomy( $taxonomy );
  
! 		if ( ! $tax->public )
  			return $count;
  
  		if ( $tax->query_var ) {
--- 289,296 ----
  
  		$tax = get_taxonomy( $taxonomy );
  
! 		$ptype_object = get_post_type_object( $post_type );
! 		if ( ! $ptype_object->show_ui )
  			return $count;
  
  		if ( $tax->query_var ) {
***************
*** 299,305 ****
  			$args = array( 'taxonomy' => $tax->name, 'term' => $tag->slug );
  		}
  
! 		$args['post_type'] = $post_type;
  
  		return "<a href='" . esc_url ( add_query_arg( $args, 'edit.php' ) ) . "'>$count</a>";
  	}
--- 299,306 ----
  			$args = array( 'taxonomy' => $tax->name, 'term' => $tag->slug );
  		}
  
! 		if ( 'post' != $post_type )
! 			$args['post_type'] = $post_type;
  
  		return "<a href='" . esc_url ( add_query_arg( $args, 'edit.php' ) ) . "'>$count</a>";
  	}
***************
*** 323,329 ****
  	 * @since 3.1.0
  	 */
  	function inline_edit() {
! 		global $tax;
  
  		if ( ! current_user_can( $tax->cap->edit_terms ) )
  			return;
--- 324,330 ----
  	 * @since 3.1.0
  	 */
  	function inline_edit() {
! 		global $post_type, $tax;
  
  		if ( ! current_user_can( $tax->cap->edit_terms ) )
  			return;
***************
*** 362,374 ****
  	?>
  
  		<p class="inline-edit-save submit">
! 			<a accesskey="c" href="#inline-edit" title="<?php _e( 'Cancel' ); ?>" class="cancel button-secondary alignleft"><?php _e( 'Cancel' ); ?></a>
  			<?php $update_text = $tax->labels->update_item; ?>
  			<a accesskey="s" href="#inline-edit" title="<?php echo esc_attr( $update_text ); ?>" class="save button-primary alignright"><?php echo $update_text; ?></a>
  			<img class="waiting" style="display:none;" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  			<span class="error" style="display:none;"></span>
  			<?php wp_nonce_field( 'taxinlineeditnonce', '_inline_edit', false ); ?>
  			<input type="hidden" name="taxonomy" value="<?php echo esc_attr( $tax->name ); ?>" />
  			<br class="clear" />
  		</p>
  		</td></tr>
--- 363,376 ----
  	?>
  
  		<p class="inline-edit-save submit">
! 			<a accesskey="c" href="#inline-edit" title="<?php esc_attr_e( 'Cancel' ); ?>" class="cancel button-secondary alignleft"><?php _e( 'Cancel' ); ?></a>
  			<?php $update_text = $tax->labels->update_item; ?>
  			<a accesskey="s" href="#inline-edit" title="<?php echo esc_attr( $update_text ); ?>" class="save button-primary alignright"><?php echo $update_text; ?></a>
  			<img class="waiting" style="display:none;" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  			<span class="error" style="display:none;"></span>
  			<?php wp_nonce_field( 'taxinlineeditnonce', '_inline_edit', false ); ?>
  			<input type="hidden" name="taxonomy" value="<?php echo esc_attr( $tax->name ); ?>" />
+ 			<input type="hidden" name="post_type" value="<?php echo esc_attr( $post_type ); ?>" />
  			<br class="clear" />
  		</p>
  		</td></tr>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/class-wp-theme-install-list-table.php ./wordpress-3.3/wp-admin/includes/class-wp-theme-install-list-table.php
*** ./wordpress-3.2.1/wp-admin/includes/class-wp-theme-install-list-table.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/class-wp-theme-install-list-table.php	2011-09-14 23:26:26.000000000 -0500
***************
*** 22,28 ****
  
  		$paged = $this->get_pagenum();
  
! 		$per_page = 30;
  
  		// These are the tabs which are shown on the page,
  		$tabs = array();
--- 22,28 ----
  
  		$paged = $this->get_pagenum();
  
! 		$per_page = 36;
  
  		// These are the tabs which are shown on the page,
  		$tabs = array();
***************
*** 130,136 ****
  
  		// wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
! 		<div class="tablenav top">
  			<div class="alignleft actions">
  				<?php do_action( 'install_themes_table_header' ); ?>
  			</div>
--- 130,136 ----
  
  		// wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
! 		<div class="tablenav top themes">
  			<div class="alignleft actions">
  				<?php do_action( 'install_themes_table_header' ); ?>
  			</div>
***************
*** 139,151 ****
  			<br class="clear" />
  		</div>
  
! 		<table id="availablethemes" cellspacing="0" cellpadding="0">
! 			<tbody id="the-list" class="list:themes">
! 				<?php $this->display_rows_or_placeholder(); ?>
! 			</tbody>
! 		</table>
  
! 		<div class="tablenav bottom">
  			<?php $this->pagination( 'bottom' ); ?>
  			<img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  			<br class="clear" />
--- 139,149 ----
  			<br class="clear" />
  		</div>
  
! 		<div id="availablethemes">
! 			<?php $this->display_rows_or_placeholder(); ?>
! 		</div>
  
! 		<div class="tablenav bottom themes">
  			<?php $this->pagination( 'bottom' ); ?>
  			<img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  			<br class="clear" />
***************
*** 155,184 ****
  
  	function display_rows() {
  		$themes = $this->items;
  
! 		$rows = ceil( count( $themes ) / 3 );
! 		$table = array();
! 		$theme_keys = array_keys( $themes );
! 		for ( $row = 1; $row <= $rows; $row++ )
! 			for ( $col = 1; $col <= 3; $col++ )
! 				$table[$row][$col] = array_shift( $theme_keys );
! 
! 		foreach ( $table as $row => $cols ) {
! 			echo "\t<tr>\n";
! 			foreach ( $cols as $col => $theme_index ) {
  				$class = array( 'available-theme' );
- 				if ( $row == 1 ) $class[] = 'top';
- 				if ( $col == 1 ) $class[] = 'left';
- 				if ( $row == $rows ) $class[] = 'bottom';
- 				if ( $col == 3 ) $class[] = 'right';
  				?>
! 				<td class="<?php echo join( ' ', $class ); ?>"><?php
! 					if ( isset( $themes[$theme_index] ) )
! 						display_theme( $themes[$theme_index] );
! 				?></td>
! 			<?php } // end foreach $cols
! 			echo "\t</tr>\n";
! 		} // end foreach $table
  	}
  }
  
--- 153,168 ----
  
  	function display_rows() {
  		$themes = $this->items;
+ 		$theme_names = array_keys( $themes );
  
! 		foreach ( $theme_names as $theme_name ) {
  				$class = array( 'available-theme' );
  				?>
! 				<div class="<?php echo join( ' ', $class ); ?>"><?php
! 					if ( isset( $themes[$theme_name] ) )
! 						display_theme( $themes[$theme_name] );
! 				?></div>
! 		<?php } // end foreach $theme_names
  	}
  }
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/class-wp-themes-list-table.php ./wordpress-3.3/wp-admin/includes/class-wp-themes-list-table.php
*** ./wordpress-3.2.1/wp-admin/includes/class-wp-themes-list-table.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/class-wp-themes-list-table.php	2011-09-14 23:26:26.000000000 -0500
***************
*** 47,53 ****
  		unset( $themes[$ct->name] );
  		uksort( $themes, "strnatcasecmp" );
  
! 		$per_page = 15;
  		$page = $this->get_pagenum();
  
  		$start = ( $page - 1 ) * $per_page;
--- 47,53 ----
  		unset( $themes[$ct->name] );
  		uksort( $themes, "strnatcasecmp" );
  
! 		$per_page = 24;
  		$page = $this->get_pagenum();
  
  		$start = ( $page - 1 ) * $per_page;
***************
*** 92,98 ****
  		if ( $this->get_pagination_arg( 'total_pages' ) <= 1 )
  			return;
  		?>
! 		<div class="tablenav <?php echo $which; ?>">
  			<?php $this->pagination( $which ); ?>
  		   <img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  		  <br class="clear" />
--- 92,98 ----
  		if ( $this->get_pagination_arg( 'total_pages' ) <= 1 )
  			return;
  		?>
! 		<div class="tablenav themes <?php echo $which; ?>">
  			<?php $this->pagination( $which ); ?>
  		   <img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  		  <br class="clear" />
***************
*** 105,115 ****
  ?>
  		<?php $this->tablenav( 'top' ); ?>
  
! 		<table id="availablethemes" cellspacing="0" cellpadding="0">
! 			<tbody id="the-list" class="list:themes">
! 				<?php $this->display_rows_or_placeholder(); ?>
! 			</tbody>
! 		</table>
  
  		<?php $this->tablenav( 'bottom' ); ?>
  <?php
--- 105,113 ----
  ?>
  		<?php $this->tablenav( 'top' ); ?>
  
! 		<div id="availablethemes">
! 			<?php $this->display_rows_or_placeholder(); ?>
! 		</div>
  
  		<?php $this->tablenav( 'bottom' ); ?>
  <?php
***************
*** 124,148 ****
  		$theme_names = array_keys( $themes );
  		natcasesort( $theme_names );
  
! 		$table = array();
! 		$rows = ceil( count( $theme_names ) / 3 );
! 		for ( $row = 1; $row <= $rows; $row++ )
! 			for ( $col = 1; $col <= 3; $col++ )
! 				$table[$row][$col] = array_shift( $theme_names );
! 
! 		foreach ( $table as $row => $cols ) {
! ?>
! <tr>
! <?php
! foreach ( $cols as $col => $theme_name ) {
! 	$class = array( 'available-theme' );
! 	if ( $row == 1 ) $class[] = 'top';
! 	if ( $col == 1 ) $class[] = 'left';
! 	if ( $row == $rows ) $class[] = 'bottom';
! 	if ( $col == 3 ) $class[] = 'right';
! ?>
! 	<td class="<?php echo join( ' ', $class ); ?>">
! <?php if ( !empty( $theme_name ) ) :
  	$template = $themes[$theme_name]['Template'];
  	$stylesheet = $themes[$theme_name]['Stylesheet'];
  	$title = $themes[$theme_name]['Title'];
--- 122,132 ----
  		$theme_names = array_keys( $themes );
  		natcasesort( $theme_names );
  
! 	foreach ( $theme_names as $theme_name ) {
! 		$class = array( 'available-theme' );
! 	?>
! 	<div class="<?php echo join( ' ', $class ); ?>">
! 	<?php if ( !empty( $theme_name ) ) :
  	$template = $themes[$theme_name]['Template'];
  	$stylesheet = $themes[$theme_name]['Stylesheet'];
  	$title = $themes[$theme_name]['Title'];
***************
*** 194,203 ****
  <?php endif; ?>
  		<?php theme_update_available( $themes[$theme_name] ); ?>
  <?php endif; // end if not empty theme_name ?>
! 	</td>
! <?php } // end foreach $cols ?>
! </tr>
! <?php } // end foreach $table
  	}
  
  	function search_theme( $theme ) {
--- 178,185 ----
  <?php endif; ?>
  		<?php theme_update_available( $themes[$theme_name] ); ?>
  <?php endif; // end if not empty theme_name ?>
! 	</div>
! <?php } // end foreach $theme_names
  	}
  
  	function search_theme( $theme ) {
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/class-wp-upgrader.php ./wordpress-3.3/wp-admin/includes/class-wp-upgrader.php
*** ./wordpress-3.2.1/wp-admin/includes/class-wp-upgrader.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/class-wp-upgrader.php	2011-11-10 13:41:44.000000000 -0600
***************
*** 52,58 ****
  		$this->strings['installing_package'] = __('Installing the latest version&#8230;');
  		$this->strings['folder_exists'] = __('Destination folder already exists.');
  		$this->strings['mkdir_failed'] = __('Could not create directory.');
! 		$this->strings['bad_package'] = __('Incompatible Archive.');
  
  		$this->strings['maintenance_start'] = __('Enabling Maintenance mode&#8230;');
  		$this->strings['maintenance_end'] = __('Disabling Maintenance mode&#8230;');
--- 52,58 ----
  		$this->strings['installing_package'] = __('Installing the latest version&#8230;');
  		$this->strings['folder_exists'] = __('Destination folder already exists.');
  		$this->strings['mkdir_failed'] = __('Could not create directory.');
! 		$this->strings['incompatible_archive'] = __('The package could not be installed.');
  
  		$this->strings['maintenance_start'] = __('Enabling Maintenance mode&#8230;');
  		$this->strings['maintenance_end'] = __('Disabling Maintenance mode&#8230;');
***************
*** 153,158 ****
--- 153,161 ----
  
  		if ( is_wp_error($result) ) {
  			$wp_filesystem->delete($working_dir, true);
+ 			if ( 'incompatible_archive' == $result->get_error_code() ) {
+ 				return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], $result->get_error_data() );
+ 			}
  			return $result;
  		}
  
***************
*** 190,197 ****
  		if ( 1 == count($source_files) && $wp_filesystem->is_dir( trailingslashit($source) . $source_files[0] . '/') ) //Only one folder? Then we want its contents.
  			$source = trailingslashit($source) . trailingslashit($source_files[0]);
  		elseif ( count($source_files) == 0 )
! 			return new WP_Error('bad_package', $this->strings['bad_package']); //There are no files?
! 		//else //Its only a single file, The upgrader will use the foldername of this file as the destination folder. foldername is based on zip filename.
  
  		//Hook ability to change the source file location..
  		$source = apply_filters('upgrader_source_selection', $source, $remote_source, $this);
--- 193,201 ----
  		if ( 1 == count($source_files) && $wp_filesystem->is_dir( trailingslashit($source) . $source_files[0] . '/') ) //Only one folder? Then we want its contents.
  			$source = trailingslashit($source) . trailingslashit($source_files[0]);
  		elseif ( count($source_files) == 0 )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __( 'The plugin contains no files.' ) ); //There are no files?
! 		else //Its only a single file, The upgrader will use the foldername of this file as the destination folder. foldername is based on zip filename.
! 			$source = trailingslashit($source);
  
  		//Hook ability to change the source file location..
  		$source = apply_filters('upgrader_source_selection', $source, $remote_source, $this);
***************
*** 209,215 ****
  		}
  
  		if ( $clear_destination ) {
! 			//We're going to clear the destination if theres something there
  			$this->skin->feedback('remove_old');
  			$removed = true;
  			if ( $wp_filesystem->exists($remote_destination) )
--- 213,219 ----
  		}
  
  		if ( $clear_destination ) {
! 			//We're going to clear the destination if there's something there
  			$this->skin->feedback('remove_old');
  			$removed = true;
  			if ( $wp_filesystem->exists($remote_destination) )
***************
*** 221,227 ****
  			else if ( ! $removed )
  				return new WP_Error('remove_old_failed', $this->strings['remove_old_failed']);
  		} elseif ( $wp_filesystem->exists($remote_destination) ) {
! 			//If we're not clearing the destination folder and something exists there allready, Bail.
  			//But first check to see if there are actually any files in the folder.
  			$_files = $wp_filesystem->dirlist($remote_destination);
  			if ( ! empty($_files) ) {
--- 225,231 ----
  			else if ( ! $removed )
  				return new WP_Error('remove_old_failed', $this->strings['remove_old_failed']);
  		} elseif ( $wp_filesystem->exists($remote_destination) ) {
! 			//If we're not clearing the destination folder and something exists there already, Bail.
  			//But first check to see if there are actually any files in the folder.
  			$_files = $wp_filesystem->dirlist($remote_destination);
  			if ( ! empty($_files) ) {
***************
*** 301,307 ****
  
  		$delete_package = ($download != $package); // Do not delete a "local" file
  
! 		//Unzip's the file into a temporary directory
  		$working_dir = $this->unpack_package( $download, $delete_package );
  		if ( is_wp_error($working_dir) ) {
  			$this->skin->error($working_dir);
--- 305,311 ----
  
  		$delete_package = ($download != $package); // Do not delete a "local" file
  
! 		//Unzips the file into a temporary directory
  		$working_dir = $this->unpack_package( $download, $delete_package );
  		if ( is_wp_error($working_dir) ) {
  			$this->skin->error($working_dir);
***************
*** 322,328 ****
  			$this->skin->error($result);
  			$this->skin->feedback('process_failed');
  		} else {
! 			//Install Suceeded
  			$this->skin->feedback('process_success');
  		}
  		$this->skin->after();
--- 326,332 ----
  			$this->skin->error($result);
  			$this->skin->feedback('process_failed');
  		} else {
! 			//Install Succeeded
  			$this->skin->feedback('process_success');
  		}
  		$this->skin->after();
***************
*** 391,396 ****
--- 395,402 ----
  		$this->init();
  		$this->install_strings();
  
+ 		add_filter('upgrader_source_selection', array(&$this, 'check_package') );
+ 
  		$this->run(array(
  					'package' => $package,
  					'destination' => WP_PLUGIN_DIR,
***************
*** 399,407 ****
--- 405,419 ----
  					'hook_extra' => array()
  					));
  
+ 		remove_filter('upgrader_source_selection', array(&$this, 'check_package') );
+ 
+ 		if ( ! $this->result || is_wp_error($this->result) )
+ 			return $this->result;
+ 
  		// Force refresh of plugin update information
  		delete_site_transient('update_plugins');
  
+ 		return true;
  	}
  
  	function upgrade($plugin) {
***************
*** 423,429 ****
  
  		add_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'), 10, 2);
  		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'), 10, 4);
! 		//'source_selection' => array(&$this, 'source_selection'), //theres a track ticket to move up the directory for zip's which are made a bit differently, useful for non-.org plugins.
  
  		$this->run(array(
  					'package' => $r->package,
--- 435,441 ----
  
  		add_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'), 10, 2);
  		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'), 10, 4);
! 		//'source_selection' => array(&$this, 'source_selection'), //there's a trac ticket to move up the directory for zip's which are made a bit differently, useful for non-.org plugins.
  
  		$this->run(array(
  					'package' => $r->package,
***************
*** 435,441 ****
  					)
  				));
  
! 		// Cleanup our hooks, incase something else does a upgrade on this connection.
  		remove_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'));
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
--- 447,453 ----
  					)
  				));
  
! 		// Cleanup our hooks, in case something else does a upgrade on this connection.
  		remove_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'));
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
***************
*** 520,526 ****
  
  		$this->skin->footer();
  
! 		// Cleanup our hooks, incase something else does a upgrade on this connection.
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
  		// Force refresh of plugin update information
--- 532,538 ----
  
  		$this->skin->footer();
  
! 		// Cleanup our hooks, in case something else does a upgrade on this connection.
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
  		// Force refresh of plugin update information
***************
*** 529,534 ****
--- 541,572 ----
  		return $results;
  	}
  
+ 	function check_package($source) {
+ 		global $wp_filesystem;
+ 
+ 		if ( is_wp_error($source) )
+ 			return $source;
+ 
+ 		$working_directory = str_replace( $wp_filesystem->wp_content_dir(), trailingslashit(WP_CONTENT_DIR), $source);
+ 		if ( ! is_dir($working_directory) ) // Sanity check, if the above fails, lets not prevent installation.
+ 			return $source;
+ 
+ 		// Check the folder contains at least 1 valid plugin.
+ 		$plugins_found = false;
+ 		foreach ( glob( $working_directory . '*.php' ) as $file ) {
+ 			$info = get_plugin_data($file, false, false);
+ 			if ( !empty( $info['Name'] ) ) {
+ 				$plugins_found = true;
+ 				break;
+ 			}
+ 		}
+ 
+ 		if ( ! $plugins_found )
+ 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('No valid plugins were found.') );
+ 
+ 		return $source;
+ 	}
+ 
  	//return plugin info.
  	function plugin_info() {
  		if ( ! is_array($this->result) )
***************
*** 604,609 ****
--- 642,648 ----
  class Theme_Upgrader extends WP_Upgrader {
  
  	var $result;
+ 	var $bulk = false;
  
  	function upgrade_strings() {
  		$this->strings['up_to_date'] = __('The theme is at the latest version.');
***************
*** 630,635 ****
--- 669,676 ----
  		$this->init();
  		$this->install_strings();
  
+ 		add_filter('upgrader_source_selection', array(&$this, 'check_package') );
+ 
  		$options = array(
  						'package' => $package,
  						'destination' => WP_CONTENT_DIR . '/themes',
***************
*** 639,654 ****
  
  		$this->run($options);
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of theme update information
  		delete_site_transient('update_themes');
  
! 		if ( empty($result['destination_name']) )
! 			return false;
! 		else
! 			return $result['destination_name'];
  	}
  
  	function upgrade($theme) {
--- 680,694 ----
  
  		$this->run($options);
  
+ 		remove_filter('upgrader_source_selection', array(&$this, 'check_package') );
+ 
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of theme update information
  		delete_site_transient('update_themes');
  
! 		return true;
  	}
  
  	function upgrade($theme) {
***************
*** 684,689 ****
--- 724,733 ----
  
  		$this->run($options);
  
+ 		remove_filter('upgrader_pre_install', array(&$this, 'current_before'), 10, 2);
+ 		remove_filter('upgrader_post_install', array(&$this, 'current_after'), 10, 2);
+ 		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'), 10, 4);
+ 
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
***************
*** 769,775 ****
  
  		$this->skin->footer();
  
! 		// Cleanup our hooks, incase something else does a upgrade on this connection.
  		remove_filter('upgrader_pre_install', array(&$this, 'current_before'), 10, 2);
  		remove_filter('upgrader_post_install', array(&$this, 'current_after'), 10, 2);
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'), 10, 4);
--- 813,819 ----
  
  		$this->skin->footer();
  
! 		// Cleanup our hooks, in case something else does a upgrade on this connection.
  		remove_filter('upgrader_pre_install', array(&$this, 'current_before'), 10, 2);
  		remove_filter('upgrader_post_install', array(&$this, 'current_after'), 10, 2);
  		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'), 10, 4);
***************
*** 780,785 ****
--- 824,853 ----
  		return $results;
  	}
  
+ 	function check_package($source) {
+ 		global $wp_filesystem;
+ 
+ 		if ( is_wp_error($source) )
+ 			return $source;
+ 
+ 		// Check the folder contains a valid theme
+ 		$working_directory = str_replace( $wp_filesystem->wp_content_dir(), trailingslashit(WP_CONTENT_DIR), $source);
+ 		if ( ! is_dir($working_directory) ) // Sanity check, if the above fails, lets not prevent installation.
+ 			return $source;
+ 
+ 		if ( ! file_exists( $working_directory . 'style.css' ) ) // A proper archive should have a style.css file in the single subdirectory
+ 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('The theme is missing the <code>style.css</code> stylesheet.') );
+ 
+ 		$info = get_theme_data( $working_directory . 'style.css' );
+ 		if ( empty($info['Name']) )
+ 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __("The <code>style.css</code> stylesheet doesn't contain a valid theme header.") );
+ 
+ 		if ( empty($info['Template']) && ! file_exists( $working_directory . 'index.php' ) ) // If no template is set, it must have at least an index.php to be legit.
+ 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('The theme is missing the <code>index.php</code> file.') );
+ 
+ 		return $source;
+ 	}
+ 
  	function current_before($return, $theme) {
  
  		if ( is_wp_error($return) )
***************
*** 805,811 ****
  			return $return;
  
  		//Ensure stylesheet name hasnt changed after the upgrade:
! 		// @TODO: Note, This doesnt handle the Template changing, or the Template name changing.
  		if ( $theme == get_stylesheet() && $theme != $this->result['destination_name'] ) {
  			$theme_info = $this->theme_info();
  			$stylesheet = $this->result['destination_name'];
--- 874,880 ----
  			return $return;
  
  		//Ensure stylesheet name hasnt changed after the upgrade:
! 		// @TODO: Note, This doesn't handle the Template changing, or the Template name changing.
  		if ( $theme == get_stylesheet() && $theme != $this->result['destination_name'] ) {
  			$theme_info = $this->theme_info();
  			$stylesheet = $this->result['destination_name'];
***************
*** 848,854 ****
  }
  
  /**
!  * Core Upgrader class for WordPress. It allows for WordPress to upgrade itself in combiantion with the wp-admin/includes/update-core.php file
   *
   * @TODO More Detailed docs, for methods as well.
   *
--- 917,923 ----
  }
  
  /**
!  * Core Upgrader class for WordPress. It allows for WordPress to upgrade itself in combination with the wp-admin/includes/update-core.php file
   *
   * @TODO More Detailed docs, for methods as well.
   *
***************
*** 1353,1358 ****
--- 1422,1430 ----
  			'activate' => '<a href="' . $activate_link .  '" class="activatelink" title="' . esc_attr( sprintf( __('Activate &#8220;%s&#8221;'), $name ) ) . '">' . __('Activate') . '</a>'
  							);
  
+ 		if ( is_network_admin() && current_user_can( 'manage_network_themes' ) )
+ 			$install_actions['network_enable'] = '<a href="' . esc_url( wp_nonce_url( 'themes.php?action=enable&amp;theme=' . $template, 'enable-theme_' . $template ) ) . '" title="' . esc_attr__( 'Enable this theme for all sites in this network' ) . '" target="_parent">' . __( 'Network Enable' ) . '</a>';
+ 
  		if ( $this->type == 'web' )
  			$install_actions['themes_page'] = '<a href="' . self_admin_url('theme-install.php') . '" title="' . esc_attr__('Return to Theme Installer') . '" target="_parent">' . __('Return to Theme Installer') . '</a>';
  		else
***************
*** 1429,1457 ****
  class File_Upload_Upgrader {
  	var $package;
  	var $filename;
  
  	function __construct($form, $urlholder) {
- 		if ( ! ( ( $uploads = wp_upload_dir() ) && false === $uploads['error'] ) )
- 			wp_die($uploads['error']);
  
  		if ( empty($_FILES[$form]['name']) && empty($_GET[$urlholder]) )
  			wp_die(__('Please select a file'));
  
! 		if ( !empty($_FILES) )
  			$this->filename = $_FILES[$form]['name'];
! 		else if ( isset($_GET[$urlholder]) )
! 			$this->filename = $_GET[$urlholder];
  
! 		//Handle a newly uploaded file, Else assume its already been uploaded
! 		if ( !empty($_FILES) ) {
! 			$this->filename = wp_unique_filename( $uploads['basedir'], $this->filename );
! 			$this->package = $uploads['basedir'] . '/' . $this->filename;
  
! 			// Move the file to the uploads dir
! 			if ( false === @ move_uploaded_file( $_FILES[$form]['tmp_name'], $this->package) )
! 				wp_die( sprintf( __('The uploaded file could not be moved to %s.' ), $uploads['path']));
  		} else {
  			$this->package = $uploads['basedir'] . '/' . $this->filename;
  		}
  	}
! }
\ No newline at end of file
--- 1501,1566 ----
  class File_Upload_Upgrader {
  	var $package;
  	var $filename;
+ 	var $id = 0;
  
  	function __construct($form, $urlholder) {
  
  		if ( empty($_FILES[$form]['name']) && empty($_GET[$urlholder]) )
  			wp_die(__('Please select a file'));
  
! 		//Handle a newly uploaded file, Else assume its already been uploaded
! 		if ( ! empty($_FILES) ) {
! 			$overrides = array( 'test_form' => false, 'test_type' => false );
! 			$file = wp_handle_upload( $_FILES[$form], $overrides );
! 
! 			if ( isset( $file['error'] ) )
! 				wp_die( $file['error'] );
! 
  			$this->filename = $_FILES[$form]['name'];
! 			$this->package = $file['file'];
  
! 			// Construct the object array
! 			$object = array(
! 				'post_title' => $this->filename,
! 				'post_content' => $file['url'],
! 				'post_mime_type' => $file['type'],
! 				'guid' => $file['url'],
! 				'context' => 'upgrader',
! 				'post_status' => 'private'
! 			);
! 
! 			// Save the data
! 			$this->id = wp_insert_attachment( $object, $file['file'] );
! 
! 			// schedule a cleanup for 2 hours from now in case of failed install
! 			wp_schedule_single_event( time() + 7200, 'upgrader_scheduled_cleanup', array( $this->id ) );
! 
! 		} elseif ( is_numeric( $_GET[$urlholder] ) ) {
! 			// Numeric Package = previously uploaded file, see above.
! 			$this->id = (int) $_GET[$urlholder];
! 			$attachment = get_post( $this->id );
! 			if ( empty($attachment) )
! 				wp_die(__('Please select a file'));
  
! 			$this->filename = $attachment->post_title;
! 			$this->package = get_attached_file( $attachment->ID );
  		} else {
+ 			// Else, It's set to something, Back compat for plugins using the old (pre-3.3) File_Uploader handler.
+ 			if ( ! ( ( $uploads = wp_upload_dir() ) && false === $uploads['error'] ) )
+ 				wp_die( $uploads['error'] );
+ 
+ 			$this->filename = $_GET[$urlholder];
  			$this->package = $uploads['basedir'] . '/' . $this->filename;
  		}
  	}
! 
! 	function cleanup() {
! 		if ( $this->id )
! 			wp_delete_attachment( $this->id );
! 
! 		elseif ( file_exists( $this->package ) )
! 			return @unlink( $this->package );
! 
! 		return true;
! 	}
! }
